--- /dev/null	Fri Dec 21 14:59:54 2018
+++ new/usr/src/Makefile.smatch	Fri Dec 21 14:59:54 2018
@@ -0,0 +1,39 @@
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+# Copyright 2018 Joyent, Inc.
+#
+
+#
+# smatch/sparse checks we always disable, due to too many false positives (or
+# simply too much legacy).
+#
+
+SMATCH_ARGS = --disable=uninitialized,check_check_deref,unreachable
+
+# VLAs are OK by us
+SMATCH_ARGS += -Wno-vla
+# don't care
+SMATCH_ARGS += -Wno-one-bit-signed-bitfield
+# there are lots of "extern void myfunc() { ... }" around
+SMATCH_ARGS += -Wno-external-function-has-definition
+# we have lots of legacy "void foo();" in headers
+SMATCH_ARGS += -Wno-old-style-definition
+SMATCH_ARGS += -Wno-strict-prototypes
+
+CERRWARN += $(SMATCH_ARGS:%=-_smatch=%)
+
+CERRWARN += $(SMOFF:%=-_smatch=--disable=%)
+
+SMATCH_ =
+SMATCH_on =
+SMATCH_off = -_smatch=off
+
+CERRWARN += $(SMATCH_$(SMATCH))
